Home

Casper Node RPC API

v1.0.0
Base URL
https://casper.nownodes.io

Authentication

api-keyAuthapiKey

API Key: api-key in header

Informational JSON-RPC Methods

chain_get_block_transfers

POST
https://casper.nownodes.io/rpc

Returns all transfer transactions included in a given block identified by hash or height.

Body

application/json
idintegerrequired

JSON-RPC request id

jsonrpcstringrequired

JSON-RPC version

methodstringrequired

RPC method name

paramsobjectrequired
Show child attributes
block_identifierobjectrequired

Block identifier to query

Show child attributes
Hashstring

Block hash in hex format

Response

200OK

Successful response with transfers in the block

Authorization

api-keyAuthapiKey in header

chain_get_block

POST
https://casper.nownodes.io/rpc

Calls chain_get_block RPC method on a Casper Node and returns the block along with validator signatures.

Body

application/json
idintegerrequired

Request identifier.

jsonrpcstringrequired

JSON-RPC protocol version.

methodstringrequired

RPC method name to call.

paramsobjectrequired

Request parameters.

Show child attributes
block_identifierobject

Block lookup object.

Show child attributes
Hashstring

32-byte block hash (HEX encoded).

Response

200OK

Successful response with block data

Authorization

api-keyAuthapiKey in header

chain_get_state_root_hash

POST
https://casper.nownodes.io/rpc

Returns the root hash of the global state at a given block identified by hash or height.

Body

application/json
idintegerrequired

JSON-RPC request identifier

jsonrpcstringrequired

JSON-RPC version

methodstringrequired

RPC method name

paramsobjectrequired
Show child attributes
block_identifierobjectrequired

Block identifier to query

Show child attributes
Heightinteger

Height of the block

Response

200OK

Successful response returning the state root hash

Authorization

api-keyAuthapiKey in header

info_get_chainspec

POST
https://casper.nownodes.io/rpc

Returns the chainspec bytes of the current network, including optional genesis accounts and global state bytes.

Body

application/json
idintegerrequired

JSON-RPC request identifier

jsonrpcstringrequired

JSON-RPC version

methodstringrequired

RPC method name

paramsArray<any>required

Parameters for the method (empty for this RPC)

Response

200OK

Successful response returning the chainspec bytes

Authorization

api-keyAuthapiKey in header

info_get_peers

POST
https://casper.nownodes.io/rpc

Executes the JSON-RPC method info_get_peers, which retrieves all known peers of the node, including their TLS identifiers and network addresses.

Body

application/json
idintegerrequired

JSON-RPC request ID

jsonrpcstringrequired

JSON-RPC protocol version

methodstringrequired

JSON-RPC method name

paramsarrayrequired

Empty array for this method

Response

200OK

Successful response with the list of peers

Authorization

api-keyAuthapiKey in header

info_get_reward

POST
https://casper.nownodes.io/rpc

Returns the reward amounts for a validator and its delegators for a given era.

Body

application/json
idintegerrequired

JSON-RPC request identifier

jsonrpcstringrequired

JSON-RPC version

methodstringrequired

RPC method name

paramsobjectrequired
Show child attributes
era_identifierobjectrequired

Era for which to query rewards

Show child attributes
Eraintegerrequired

Era number

validatorstringrequired

Hexadecimal public key of the validator

delegatorstringrequired

Hexadecimal public key of the delegator

Response

200OK

Successful response with rewards for validator and delegator

Authorization

api-keyAuthapiKey in header

info_get_status

POST
https://casper.nownodes.io/rpc

Executes the JSON-RPC method info_get_status, which returns the node's status, including protocol version, peers, block info, upgrade information, uptime, sync status, and other system details.

Body

application/json
idintegerrequired

JSON-RPC request ID

jsonrpcstringrequired

JSON-RPC protocol version

methodstringrequired

JSON-RPC method name

paramsarrayrequired

Empty array for this method

Response

200OK

Successful response containing node status information

Authorization

api-keyAuthapiKey in header

info_get_transaction

POST
https://casper.nownodes.io/rpc

Returns detailed information about a transaction.

Body

application/json
idintegerrequired

JSON-RPC request identifier

jsonrpcstringrequired
methodstringrequired
paramsobjectrequired

Parameters for the transaction request

Show child attributes
transaction_hashobjectrequired

Transaction hash object

Show child attributes
Version1stringrequired

Transaction hash (Version1)

finalized_approvalsbooleanrequired

Include finalized approvals

Response

200OK

Successful response

Authorization

api-keyAuthapiKey in header

query_balance_details

POST
https://casper.nownodes.io/rpc

Retrieves detailed balance information for a given purse under an account. Includes total balance, available balance, holds (if any), and cryptographic proof.

Body

application/json
idintegerrequired

Unique identifier for the JSON-RPC request

jsonrpcstringrequired

JSON-RPC version (should be "2.0")

methodstringrequired

The method to call

paramsobjectrequired

Parameters for the method

Show child attributes
state_identifierobject | objectrequired

Block or state root hash to query against

purse_identifierobjectrequired

Purse identifier under an account

Show child attributes
main_purse_under_account_hashstringrequired

The account hash of the main purse

Response

200OK

Successful response with balance details

Authorization

api-keyAuthapiKey in header

query_balance

POST
https://casper.nownodes.io/rpc

Sends a JSON-RPC request to query the balance of a specific purse under an account identified either by StateRootHash or BlockHash.

Body

application/json
idintegerrequired

The request identifier

jsonrpcstringrequired

JSON-RPC version

methodstringrequired

The JSON-RPC method name

paramsobjectrequired
Show child attributes
state_identifierany | anyrequired

The state root or block hash used to query the state

purse_identifierobjectrequired

Identifier for the purse whose balance is being queried

Show child attributes
main_purse_under_account_hashstring

The account hash of the main purse under the account

Response

200OK

Successful response with the balance

Authorization

api-keyAuthapiKey in header

query_global_state

POST
https://casper.nownodes.io/rpc

Executes the query_global_state RPC call to retrieve the value associated with a key in the global state.
Returns block header, stored value, and a Merkle proof.

Body

application/json
idinteger

JSON-RPC request identifier

jsonrpcstring

JSON-RPC version

methodstring

RPC method name

paramsobject

Parameters for the query_global_state RPC

Show child attributes
state_identifierobject

Block identifier to query the state at

Show child attributes
BlockHashstring

The hash of the block

keystring

Key to query in the global state (can be a URef or deploy hash)

pathArray<string>

Path within the stored value (empty array if root)

Response

200OK

Successful query response

Authorization

api-keyAuthapiKey in header

state_get_account_info

POST
https://casper.nownodes.io/rpc

Returns detailed information about a specific account at a given block.

Body

application/json
idinteger

Unique request ID.

jsonrpcstring

JSON-RPC version.

methodstring

RPC method name.

paramsobject

Parameters for the query.

Show child attributes
account_identifierstring

Account hash of the queried account.

block_identifierobject

Specifies the block to query by hash or height.

Show child attributes
Hashstring

Block hash to query.

Response

200OK

Successful response with account information.

Authorization

api-keyAuthapiKey in header

state_get_dictionary_item

POST
https://casper.nownodes.io/rpc

Retrieves the value stored under a specific dictionary key in global state.

Body

application/json
idinteger

Unique request identifier

jsonrpcstring

JSON-RPC protocol version

methodstring

RPC method to call

paramsobject

Parameters for the dictionary query

Show child attributes
state_root_hashstring

The root hash of the state from which to query

dictionary_identifierobject

Identifier of the dictionary item

Show child attributes
URefobject

Dictionary item identified by a URef

Show child attributes
seed_urefstring

The unforgeable reference (URef) of the dictionary

dictionary_item_keystring

The key of the dictionary item to query

Response

200OK

Successful response with dictionary item value

Authorization

api-keyAuthapiKey in header

Proof-of-Stake JSON-RPC Methods

info_get_validator_changes

POST
https://casper.nownodes.io/rpc

Retrieves the list of validator changes at the current block. This is a JSON-RPC call to the Casper node.

Body

application/json

JSON-RPC request object

jsonrpcstringrequired

JSON-RPC protocol version

methodstringrequired

The RPC method to call

paramsobjectrequired

Parameters for the method (empty object)

idintegerrequired

Request identifier

Response

200OK

Successful response with validator changes

Authorization

api-keyAuthapiKey in header

Transactional JSON-RPC Methods

account_put_transaction

POST
https://casper.nownodes.io/rpc

Submits a Version1 transaction to the Casper blockchain. Returns the hash of the accepted transaction.

Body

application/json

JSON-RPC request

jsonrpcstringrequired

JSON-RPC protocol version

methodstringrequired

RPC method

paramsobjectrequired

Object containing the transaction to submit

Show child attributes
transactionobject

Transaction object

Show child attributes
Version1object

Version1 transaction

Show child attributes
hashstring

Transaction hash

headerobject

Metadata for the transaction

Show child attributes
chain_namestring

Name of the blockchain

timestampstring<date-time>

Transaction creation time

ttlstring

Time-to-live of the transaction

body_hashstring

Hash of the transaction payload

pricing_modeobject

Gas pricing mode

Show child attributes
Fixedobject
Show child attributes
gas_price_toleranceinteger

Allowed tolerance for gas price

payloadobject

Transaction fields and arguments

Show child attributes
fieldsobject
Show child attributes
initiator_addrobject
Show child attributes
PublicKeystring

Public key of transaction initiator

argsArray<Array<object>>

Arguments for the transaction

targetstring

Target of the transaction

entry_pointstring

Entry point function

transaction_categoryinteger

Transaction category

schedulingstring

Scheduling type

approvalsArray<object>

List of approvals (signatures)

Show child attributes
signerstring

Public key of signer

signaturestring

Signature of the transaction

Response

200OK

Transaction submitted successfully

Authorization

api-keyAuthapiKey in header

speculative_exec_txn

POST
https://casper.nownodes.io/rpc

Executes a Version1 transaction locally without committing it to the blockchain. Returns the execution result.

Body

application/json

JSON-RPC request

jsonrpcstringrequired

JSON-RPC protocol version

methodstringrequired

RPC method

paramsobjectrequired

Transaction object to execute speculatively

Show child attributes
transactionobject
Show child attributes
Version1object

Version1 transaction

Show child attributes
headerobject

Metadata for the transaction

Show child attributes
chain_namestring
timestampstring<date-time>
ttlstring
body_hashstring
pricing_modeobject
Show child attributes
Fixedobject
Show child attributes
gas_price_toleranceinteger
payloadobject

Transaction fields and arguments

Show child attributes
fieldsobject
Show child attributes
initiator_addrobject
Show child attributes
PublicKeystring
argsArray<Array<object>>

Arguments for the transaction

targetstring
entry_pointstring
transaction_categoryinteger
schedulingstring
approvalsArray<object>

List of approvals (can be empty for speculative execution)

Show child attributes
signerstring
signaturestring

Response

200OK

Speculative execution result

Authorization

api-keyAuthapiKey in header